
/*
**
**  $VER: drawablepicdtc.c 1.1 (25.4.97)
**  drawablepicdtc 1.1
**
**  main file
**
**  (C) Copyright 1996/1997 by Roland 'Gizzy' Mainz
**          All Rights Reserved
**
*/

/* amiga includes */
#include <exec/types.h>
#include <exec/memory.h>
#include <exec/execbase.h>
#include <exec/alerts.h>
#include <dos/dostags.h>
#include <intuition/icclass.h>
#include <datatypes/datatypesclass.h>
#include <datatypes/pictureclass.h>

/* amiga prototypes */
#include <clib/macros.h>
#include <clib/exec_protos.h>
#include <clib/utility_protos.h>
#include <clib/dos_protos.h>
#include <clib/graphics_protos.h>
#include <clib/intuition_protos.h>
#include <clib/datatypes_protos.h>
#include <clib/dtclass_protos.h>
#include <clib/alib_protos.h>

/* amiga pragmas */
#include <pragmas/exec_pragmas.h>
#include <pragmas/utility_pragmas.h>
#include <pragmas/dos_pragmas.h>
#include <pragmas/graphics_pragmas.h>
#include <pragmas/intuition_pragmas.h>
#include <pragmas/datatypes_pragmas.h>
#include <pragmas/dtclass_pragmas.h>
#include <pragmas/alib_pragmas.h> /* tagcall stubs */

/* ANSI includes */
#include <string.h>

/* version string */
#include "drawablepicdtc_rev.h"

/* misc defines */
#ifndef NAME
#define NAME "drawablepicdtc"
#endif /* !NAME */

/* SASC specific defines */
#define DISPATCHERFLAGS __saveds __asm
#define REGARGS __asm
#define REGA0 register __a0
#define REGA1 register __a1
#define REGA2 register __a2

/* version_string */
STRPTR versionstring = VERSTAG;

#define V( x )      ((VOID *)(x))
#define G( o )      ((struct Gadget *)(o))
#define EXTG( o )   ((struct ExtGadget *)(o))

#define XTAG( expr, tagid ) ((Tag)((expr)?(tagid):(TAG_IGNORE)))

long main_retval,
     main_retval2;

extern struct ExecBase *SysBase;
extern struct Library  *DOSBase;

struct ClassBase
{
    struct ExecBase *cb_SysBase;
    struct Library  *cb_UtilityBase;
    struct Library  *cb_GfxBase;
    struct Library  *cb_IntuitionBase;
    struct Library  *cb_DataTypesBase;
};


/* drawablepicdtc instance data */
struct DrawablePicDTClassInstData
{
    ULONG *dpcid_Methods;
    BOOL   dpcid_UsedAsImage;
};


const
ULONG drawablepicdtc_includemethods[] =
{
    DTM_OBTAINDRAWINFO,
    DTM_DRAW,
    DTM_RELEASEDRAWINFO,
    (~0UL)
};


const
ULONG drawablepicdtc_excludemethods[] =
{
    (~0UL)
};


/* alerts */
#define MYALERT_OBTAINDRAWINFOTWICE     (0x01UL) /* DTM_OBTAINDRAWINFO twice                          */
#define MYALERT_DRAWWITHOUTHANDLE       (0x02UL) /* DTM_DRAW without DTM_OBTAINDRAWINFO               */
#define MYALERT_MISSINGRELEASEDRAWINFO  (0x03UL) /* missing DTM_RELEASEDRAWINFO at OM_DISPOSE time    */
#define MYALERT_INVALIDDRAWHANDLE       (0x04UL) /* invalid handle passed                             */
#define MYALERT_INVALIDUSAGE            (0x05UL) /* object used as image and gadget at the same time  */


REGARGS  struct IClass *(*OldObtainEngine)( void );

/* prototypes */
static REGARGS         struct IClass *NewObtainEngine( void );
static DISPATCHERFLAGS ULONG          Dispatch( REGA0 struct IClass *, REGA2 Object *o, REGA1 Msg );
static                 ULONG         *MyCopyDTSupportedMethods( struct ClassBase *, Object *, ULONG *, ULONG * );
static                 ULONG          MyNumMethods( ULONG * );
static                 ULONG         *MyFindMethod( ULONG *, ULONG );
static                 BOOL           AttemptRemoveFunction( struct ClassBase *, struct Library *, LONG, APTR, APTR );

struct IClass    *DrawablePicDTClass  = NULL;
struct ClassBase *cb                  = NULL; /* global context */


/****** drawablepicdtc/drawablepicdtc *****************************************
*
*   NAME
*        drawablepicdtc -- patches picture.datatype to act like an image
*
*   FORMAT
*        drawablepicdtc
*
*   TEMPLATE
*        ,
*
*   PATH
*        drawablepicdtc:
*
*   PURPOSE
*        This patch adds the DTM_OBTAINDRAWINFO, DTM_DRAW and
*        DTM_RELEASEDRAWINFO methods to picture.datatype;
*
*        required by many Applications.
*
*   DESCRIPTION
*
*   KNWON BUGS
*        - HACK
*
*        - Does not support tranparent colors
*
*        - Not tested with picture.datatype V43
*
*   HISTORY
*        V1.1
*          - First Aminet release
*
*   NOTE
*
*   INSTALLATION
*        After unpacking this archieve:
*
*        Shell:
*          - Unpack this archieve and copy the drawablepicdtc to
*            SYS:Utilities/
*        Copy CLONE FROM drawablepicdtc TO SYS:Utilities/
*        Put "run <>NIL: drawablepicdtc:drawablepicdtc" in your
*        "S:user-startup".
*
*        make/smake (SAS):
*          - Type 'smake install' in shell
*
*   USAGE
*        Run the programm, it will affect all new object (and subclasses of
*        picture.datatype.
*        The programm can be finished with a CTRL_C signal
*        (or Break <CLI_ID> C). It will wait for outstanding object's.
*
*   AUTHOR's REQUEST
*        By  releasing  this program I do  not  place any obligations on you,
*        feel free to share this program with your  friends (and enemies).
*
*        If you want to blame me, report any bugs, or wants a new version
*        send your letter to:
*                        Roland Mainz
*                        Hohenstaufenstrae 8
*                        52388 Nrvenich
*                        GERMANY
*
*        Phone: (+49)(0)2426/901568
*
*        EMAIL is also available:
*        GISBURN@w-specht.rhein-ruhr.de
*
*        If you want to send me attachments larger than 1MB (up to 5MB,
*        more with my permission):
*        Up to July 1997 I'm reachable using this email address, too:
*        Reinhold.A.Mainz@KBV.DE
*
*        | Please put your name and address in your mails !
*        | German mailers should add their phone numbers.
*        | See BUGS section above when submitting bug reports.
*
*        Sorry, but I can only look once a week for mails.
*        If you don't hear something from me within three weeks, please
*        send your mail again (but watch about new releases) (problems with
*        this email port are caused by reconfigurations, hackers, network
*        problems etc.).
*
*        The  entire  "drawablepicdtc"  package may  be  noncommercially
*        redistributed, provided  that  the package  is always  distributed
*        in it's complete  form (including it's documentation).  A small copy
*        fee for media costs is okay but any kind of commercial distribution
*        is strictly forbidden! Comments  and  suggestions  how  to  improve
*        this program  are generally appreciated!
*
*        Thanks to David Junod, who wrote the animation.datatype and the
*        datatypes example code, Matt Dillon for his DICE, and Olaf 'Olsen'
*        Barthel for his help, ideas and some text clips from his
*        documentations.
*
*   SEE ALSO
*       picture.datatype,
*       exec.library/SetFunction
*
*****************************************************************************
*
*/


int main( void )
{
    main_retval2 = 0L;
    main_retval  = RETURN_OK;

    /* Be sure we've a post-V38-System (DataTypes is only available on post-V38-Systems) */
    if( (SysBase -> LibNode . lib_Version) >= 39UL )
    {
      if( cb = (struct ClassBase *)AllocMem( (ULONG)sizeof( struct ClassBase ), (MEMF_PUBLIC | MEMF_CLEAR) ) )
      {
        cb -> cb_SysBase = SysBase;
#define SysBase (cb -> cb_SysBase)

        if( cb -> cb_UtilityBase = OpenLibrary( "utility.library", 39UL ) )
        {
#define UtilityBase (cb -> cb_UtilityBase)
          if( cb -> cb_GfxBase = OpenLibrary( "graphics.library", 39UL ) )
          {
#define GfxBase (cb -> cb_GfxBase)
            if( cb -> cb_IntuitionBase = OpenLibrary( "intuition.library", 39UL ) )
            {
#define IntuitionBase (cb -> cb_IntuitionBase)
              if( cb -> cb_DataTypesBase = OpenLibrary( "datatypes.library", 39UL ) )
              {
#define DataTypesBase (cb -> cb_DataTypesBase)
                struct Library *DTClassBase;
                Object         *test;
                BOOL            dopatch = FALSE;

                /* check if we picture.datatype already supports DTM_OBTAINDRAWINFO/DTM_DRAW/DTM_RELEASEDRAWINFO */
                if( test = NewDTObject( NULL, DTA_GroupID, GID_PICTURE,
                                              DTA_SourceType, DTST_RAM,
                                              TAG_DONE ) )
                {
                  ULONG *methods;

                  if( GetDTAttrs( test, DTA_Methods, (&methods), TAG_DONE ) )
                  {
                    if( !MyFindMethod( methods, DTM_OBTAINDRAWINFO ) )
                    {
                      dopatch = TRUE;
                    }
                    else
                    {
                      Printf( "*** no patch required, picture.datatype supports already\n"
                              "*** DTM_OBTAINDRAWINFO/DTM_DRAW/DTM_RELEASEDRAWINFO !\n" );
                    }
                  }

                  /* get rid of our test object... */
                  DisposeDTObject( test );
                }

                /* patch required ? */
                if( dopatch )
                {
                  /* Open picture.datatype */
                  if( DTClassBase = OpenLibrary( "datatypes/picture.datatype", 39UL ) )
                  {
                    struct IClass *PictureDTClass;

                    /* Obtain picture.datatype class ptr */
                    if( PictureDTClass = ObtainEngine() )
                    {
                      ClassID oldclassid;

                      oldclassid = PictureDTClass -> cl_ID;                       /* Save picture.datatype's public class name */
                      PictureDTClass -> cl_ID = "non_drawable_picture.datatype";  /* HACK: Replace picture.datatype's public class name */

                      /* Create our new class... */
                      if( DrawablePicDTClass = MakeClass( PICTUREDTCLASS, NULL, PictureDTClass, (ULONG)sizeof( struct DrawablePicDTClassInstData ), 0UL ) )
                      {
                        BOOL classvalid    = TRUE, /* Our drawable_picture.datatype valid ? */
                             ispatched     = TRUE; /* ObtainEngine patch installed ?     */

                        /* Prepare class for usage... */
                        DrawablePicDTClass -> cl_Dispatcher . h_Entry = (HOOKFUNC)Dispatch;
                        DrawablePicDTClass -> cl_UserData             = 0UL; /* datatypes.library expects here a (struct Library *) or NULL,
                                                                              * we cannot use this for our context
                                                                              */

                        /* Patch picture.datatype/ObrainEngine to return our class */
                        OldObtainEngine = (REGARGS struct IClass *(*)( void ))SetFunction( DTClassBase, (-30L), (ULONG (*)())NewObtainEngine );

                        /* Make our class public */
                        AddClass( DrawablePicDTClass );

                          /* Wait (until user want to quit) */
                          Wait( SIGBREAKF_CTRL_C );

                        /* Remove class from public */
                        RemoveClass( DrawablePicDTClass );

                        /* Loop until both patched function and our class are freed */
                        do
                        {
                          if( AttemptRemoveFunction( cb, DTClassBase, (-30L), (APTR)OldObtainEngine, (APTR)NewObtainEngine ) )
                          {
                            /* Wait for possible users of the patched function */
                            Delay( (TICKS_PER_SECOND / 2UL) );

                            ispatched = FALSE;
                          }

                          /* The class can only be freed AFTER our patch has been removed... */
                          if( classvalid && (ispatched == FALSE) )
                          {
                            if( FreeClass( DrawablePicDTClass) )
                            {
                              DrawablePicDTClass= NULL;

                              classvalid = FALSE;
                            }
                          }
                        } while( classvalid || ispatched );

                        /* Let other tasks partake (avoids possible race-conditions) */
                        Delay( (TICKS_PER_SECOND / 2UL) );

                        /* Done ! */
                      }
                      else
                      {
                        Printf( "can't make new picture.datatype class ! (no memory or an other incompatible patch)\n" );

                        main_retval2 = ERROR_NO_FREE_STORE;
                        main_retval  = RETURN_FAIL;
                      }

                      PictureDTClass -> cl_ID = oldclassid;
                    }
                    else
                    {
                      Printf( "can't obtain picture.datatype\n" );

                      main_retval2 = ERROR_NO_FREE_STORE;
                      main_retval  = RETURN_FAIL;
                    }

                    CloseLibrary( DTClassBase );
                  }
                  else
                  {
                    Printf( "can't open picture.datatype\n" );

                    main_retval2 = ERROR_NO_FREE_STORE;
                    main_retval  = RETURN_FAIL;
                  }
                }

                CloseLibrary( (cb -> cb_DataTypesBase) );
              }
              else
              {
                Printf( "can't open datatypes.library\n" );

                main_retval2 = ERROR_NO_FREE_STORE;
                main_retval  = RETURN_FAIL;
              }

              CloseLibrary( (cb -> cb_IntuitionBase) );
            }
            else
            {
              Printf( "can't open intuition.library\n" );

              main_retval2 = ERROR_NO_FREE_STORE;
              main_retval  = RETURN_FAIL;
            }

            CloseLibrary( (cb -> cb_GfxBase) );
          }
          else
          {
            Printf( "can't open graphics.library\n" );

            main_retval2 = ERROR_NO_FREE_STORE;
            main_retval  = RETURN_FAIL;
          }

          CloseLibrary( (cb -> cb_UtilityBase) );
        }
        else
        {
          Printf( "can't open utility.library\n" );

          main_retval2 = ERROR_NO_FREE_STORE;
          main_retval  = RETURN_FAIL;
        }

        FreeMem( (APTR)cb, (ULONG)sizeof( struct ClassBase ) );
      }
      else
      {
        main_retval2 = ERROR_NO_FREE_STORE;
        main_retval  = RETURN_FAIL;
      }
    }
    else
    {
      main_retval2 = 0L;
      main_retval  = RETURN_FAIL;
    }

    PrintFault( main_retval2, NAME );

    SetIoErr( main_retval2 );

    return( main_retval );
}


/* picture.datatype/ObtainEngine patch */
static
DISPATCHERFLAGS
struct IClass *NewObtainEngine( void )
{
    return( DrawablePicDTClass ); /* Return our new class... */
}


/* DrawablePicDTClassdispatcher */
static
DISPATCHERFLAGS
ULONG Dispatch( REGA0 struct IClass *cl, REGA2 Object *o, REGA1 Msg msg )
{
    struct DrawablePicDTClassInstData *dpcid;
    ULONG                              retval = 0UL;

    switch( msg -> MethodID )
    {
        case OM_NEW:
        {
            if( retval = DoSuperMethodA( cl, o, msg ) )
            {
              /* Get a pointer to the object data */
              dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, retval );

              /* Create array of supported methods (see OM_GET) */
              if( !(dpcid -> dpcid_Methods = MyCopyDTSupportedMethods( cb, (Object *)retval, (ULONG *)drawablepicdtc_includemethods, (ULONG *)drawablepicdtc_excludemethods )) )
              {
                /* Can't build DTA_Methods list */
                CoerceMethod( cl, (Object *)retval, OM_DISPOSE );
                retval = 0UL;

                SetIoErr( ERROR_NO_FREE_STORE );
              }
            }
        }
            break;

        case OM_DISPOSE:
        {
            dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, o );

            /* DTM_RELEASEDRAWINFO not called ? */
            if( dpcid -> dpcid_UsedAsImage )
            {
              /* Be angry ! */
              Alert( (AN_Unknown + MYALERT_MISSINGRELEASEDRAWINFO) );
            }

            /* Free methods array */
            FreeVec( (dpcid -> dpcid_Methods) );

            DoSuperMethodA( cl, o, msg );
        }
            break;

        case OM_GET:
        {
           dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, o );

            /* Redefine DTA_Methods to reflect all supported methods */
            if( ((((struct opGet *)msg) -> opg_AttrID) == DTA_Methods) && (dpcid -> dpcid_Methods) )
            {
              *(((struct opGet *)msg) -> opg_Storage) = (ULONG)(dpcid -> dpcid_Methods);

              retval = 1UL;
            }
            else
            {
              retval = DoSuperMethodA( cl, o, msg );
            }
        }
            break;

        case DTM_OBTAINDRAWINFO:
        {
            struct Screen *scr;
            struct opSet   ops = *((struct opSet *)msg);

            dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, o );

            /* Handle already obtained ? */
            if( dpcid -> dpcid_UsedAsImage )
            {
              /* Received DTM_OBTAINDRAWINFO during another handle is active */
              Alert( (AN_Unknown + MYALERT_OBTAINDRAWINFOTWICE) );
            }
            else
            {
              /* A screen is __required__ by this datatype (not general for all datatypes, 
               * but a "must" for this one... ) 
               */
              if( scr = (struct Screen *)GetTagData( PDTA_Screen, NULL, (ops . ops_AttrList) ) )
              {
                ops . MethodID = OM_SET;

                /* Set attributes (mainly PDTA_Screen, PDTA_SparseTable, etc.) */
                DoMethodA( o, (Msg)(&ops) );

                /* Layout object (initial layout) */
                if( DoMethod( o, DTM_PROCLAYOUT, NULL, 1L ) )
                {
                  struct BitMap *bm;

                  if( GetDTAttrs( o, PDTA_DestBitMap, (&bm), TAG_DONE ) == 1UL )
                  {
                    if( bm )
                    {
                      dpcid -> dpcid_UsedAsImage = TRUE;

                      retval = (ULONG)dpcid; /* return our __private__ handle */
                    }
                  }
                }
              }
            }
        }
            break;

        case DTM_DRAW:
        {
            struct dtDraw *dtd = (struct dtDraw *)msg;

            dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, o );

            /* Handle ? */
            if( dpcid -> dpcid_UsedAsImage )
            {
              /* Rastport ? */
              if( dtd -> dtd_RPort )
              {
                ULONG                hunit,
                                     vunit;
                struct BitMapHeader *bmh;
                struct BitMap       *bm;

                if( GetDTAttrs( o, DTA_HorizUnit,     (&hunit),
                                   DTA_VertUnit,      (&vunit),
                                   PDTA_BitMapHeader, (&bmh),
                                   PDTA_DestBitMap,   (&bm),
                                   TAG_DONE ) == 4UL )
                {
                  if( bm && bmh )
                  {
                    ULONG tophorizpix,
                          topvertpix,
                          destwidth,
                          destheight,
                          pwidth,
                          pheight;

                    pwidth  = bmh -> bmh_Width;
                    pheight = bmh -> bmh_Height;

                    /* offsets in src bitmap... */
                    tophorizpix = (dtd -> dtd_TopHoriz) * ((hunit > 0)?(hunit):(1UL));
                    topvertpix  = (dtd -> dtd_TopVert)  * ((vunit > 0)?(vunit):(1UL));

                    /* ... clip them */
                    tophorizpix = MIN( tophorizpix, pwidth  );
                    topvertpix  = MIN( topvertpix,  pheight );

                    /* max. available width/height */
                    pwidth  -= tophorizpix;
                    pheight -= topvertpix;

                    /* clip width/height */
                    destwidth  = MIN( pwidth,  (dtd -> dtd_Width)  );
                    destheight = MIN( pheight, (dtd -> dtd_Height) );

                    /* drawing... */
                    BltBitMapRastPort( bm, tophorizpix, topvertpix,
                                       (dtd -> dtd_RPort),
                                       (dtd -> dtd_Left), (dtd -> dtd_Top),
                                       destwidth, destheight,
                                       0xC0 );

                    /* ...done */
                    WaitBlit();

                    retval = 1UL; /* success */
                  }
                }
              }
            }
            else
            {
              /* no handle obtained, grrr...  */
              Alert( (AN_Unknown + MYALERT_DRAWWITHOUTHANDLE) );
            }
        }
            break;

        case DTM_RELEASEDRAWINFO:
        {
            struct dtReleaseDrawInfo *dtr = (struct dtReleaseDrawInfo *)msg;

            dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, o );

            if( dtr -> dtr_Handle )
            {
              if( (dtr -> dtr_Handle) == (APTR)dpcid )
              {
                dpcid -> dpcid_UsedAsImage = FALSE;

                retval = 1UL; /* success, handle released */
              }
              else
              {
                /* Wrong handle: Be angry ! */
                Alert( (AN_Unknown + MYALERT_INVALIDDRAWHANDLE) );
              }
            }
        }
            break;

        case GM_LAYOUT:
        case GM_RENDER:
        {
            dpcid = (struct DrawablePicDTClassInstData *)INST_DATA( cl, o );

            /* In "use" as an image ? */
            if( dpcid -> dpcid_UsedAsImage )
            {
              /* Can't serve in two jobs (image+gadget) ! */
              Alert( (AN_Unknown + MYALERT_INVALIDUSAGE) );
            }
        }
        /* fall through */

        /* Let the superclass handle everything else */
        default:
        {
            retval = DoSuperMethodA( cl, o, msg );
        }
            break;
    }

    return( retval );
}


/* Create a list of supported methods of this class, including all methods we support (DTA_Methods) */
static
ULONG *MyCopyDTSupportedMethods( struct ClassBase *cb, Object *o, ULONG *includemethods, ULONG *excludemethods )
{
    if( o )
    {
      ULONG *methods;

      if( methods = GetDTMethods( o ) )
      {
        ULONG  numincludemethods,
               nummethods;

        ULONG *copymethods;

        nummethods        = MyNumMethods( methods );
        numincludemethods = MyNumMethods( includemethods );

        if( copymethods = (ULONG *)AllocVec( ((nummethods + numincludemethods + 2UL) * sizeof( ULONG )), (MEMF_PUBLIC | MEMF_CLEAR) ) )
        {
          ULONG *x;

          /* Copy methods, including their terminator */
          memcpy( (void *)copymethods, (void *)methods, (size_t)((nummethods + 1UL) * sizeof( ULONG )) );

          if( includemethods )
          {
            /* Find terminator (== ~0UL) of copymethods */
            if( x = MyFindMethod( copymethods, (~0UL) ) )
            {
              memcpy( (void *)x, (void *)includemethods, (size_t)((numincludemethods + 1UL) * sizeof( ULONG )) );
            }
          }

          if( excludemethods )
          {
            while( (*excludemethods) != (~0UL) )
            {
              if( x = MyFindMethod( copymethods, (*excludemethods) ) )
              {
                *x = OM_NEW;
              }

              excludemethods++;
            }
          }

          return( copymethods );
        }
      }
    }

    return( NULL );
}


static
ULONG MyNumMethods( ULONG *methods )
{
    ULONG num = 0UL;

    if( methods )
    {
      while( (*methods) != (~0UL) )
      {
        methods++;
        num++;
      }
    }

    return( num );
}


static
ULONG *MyFindMethod( ULONG *methods, ULONG MethodID )
{
    if( methods )
    {
      while( ((*methods) != (~0UL)) && ((*methods) != MethodID) )
      {
        methods++;
      }

      if( (*methods) == MethodID )
      {
        return( methods );
      }
    }

    return( NULL );
}


static
BOOL AttemptRemoveFunction( struct ClassBase *cb, struct Library *lib, LONG offset, APTR oldfunc, APTR patchfunc )
{
    BOOL removed = FALSE;

    if( lib && offset && oldfunc && patchfunc )
    {
      APTR currfunc;

      Forbid();

        currfunc = (APTR)SetFunction( lib, offset, (ULONG (*)())oldfunc );

        /* Does the code returned from SetFunction match our patch code ? */
        if( currfunc == patchfunc )
        {
          removed = TRUE;
        }
        else
        {
          /* No, restore returned code */
          currfunc = (APTR)SetFunction( lib, offset, (ULONG (*)())currfunc );

          /* The following expression MUST never be TRUE */
          if( currfunc != oldfunc )
          {
            /* havoc found, crash expected */
            Alert( AN_Unknown + 0x1357 );
          }
        }

      Permit();
    }

    return( removed );
}


